"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var DynamicSections = /** @class */ (function (_super) {
    __extends(DynamicSections, _super);
    function DynamicSections() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.transform = function (data) {
            var sections = [];
            data.map(function (item) {
                Object.keys(item).forEach(function (key) {
                    var section = item[key];
                    var blocks = section.blocks;
                    delete section.blocks;
                    var fields = section;
                    sections.push({
                        id: key,
                        type: "dynamic",
                        name: key,
                        settings: fields,
                        blocks: blocks
                            ? blocks.map(function (block, i) { return ({
                                id: i,
                                type: "default",
                                settings: block
                            }); })
                            : []
                    });
                });
            });
            return sections;
        };
        return _this;
    }
    DynamicSections.prototype.section = function (data, i) {
        var SectionComponent = Object.values(this.props.sections).find(function (section) { return section.sectionId === data.name; });
        return SectionComponent ? (React.createElement(SectionComponent, __assign({ key: i, section: data }, this.props))) : null;
    };
    DynamicSections.prototype.sections = function (sections) {
        var _this = this;
        return sections
            ? sections.map(function (section, i) { return _this.section(section, i); })
            : [];
    };
    DynamicSections.prototype.render = function () {
        return (React.createElement("main", { className: this.props.className }, this.sections(this.props.dtkSections
            ? this.transform(this.props.dtkSections.slice())
            : this.props.data.sections)));
    };
    return DynamicSections;
}(React.Component));
exports.DynamicSections = DynamicSections;
//# sourceMappingURL=dynamic-sections.js.map